#ifndef PLAY_HPP
#define PLAY_HPP

#include <Basis/Screen.hpp>
#include "GameState.hpp"
#include "Server.hpp"

using std::cout;
using std::endl;

class Play : public Screen {
public:
	Play(char* host, char* port, string name);
	virtual ~Play();
	virtual void draw();
	virtual void drawBloomer(int b);
	virtual void update(float elapsed_time);
	virtual void handle_event(SDL_Event const &event);

	// Variables
	GameState gs;
	Server server;

	// textures for draw function
	Graphics::TextureRef t_A1;		Graphics::TextureRef t_B1;
	Graphics::TextureRef t_A2;		Graphics::TextureRef t_B2;
	Graphics::TextureRef t_A_uncon;		Graphics::TextureRef t_B_uncon;
	Graphics::TextureRef t_bloomersA;	Graphics::TextureRef t_bloomersB;
	Graphics::TextureRef t_bg;
	Graphics::TextureRef t_dish;
	Graphics::TextureRef t_dishBroken;
};

#endif //PLAY_HPP
