#ifndef CLIENT_HPP
#define CLIENT_HPP

#include <Vector/Vector.hpp>

#include <ev.h>
#include <vector>
#include <string>

#include "GameState.hpp"

using std::vector;
using std::string;

class Client {
public:
	Client(int sock, GameState* _state);
	~Client();

	//Communication stuff:
	int sock; //the current connection

	ev_io read_watcher; //watch for data to read on socket
	ev_io write_watcher; //watch for data to write on socket
	ev_timer timeout_watcher; //beware timeout on socket

	vector< uint8_t > read_buffer; //data that has been read but not processed
	vector< uint8_t > write_buffer; //data to be written

	void send_message(string message); //send an error message and close connection
	void send_update();
	void send_error(string message); //send an error message and close connection

	//add data to write buffer
	void write_data(const void *data, unsigned int bytes);

	//read data from read_buffer (returns 'false' if more data is needed)
	bool process_read();

	// Variables for the actual game:
	string name; //andrewid of player
	GameState* state; //shared by all clients
	bool suicide; //don't read or write more data, close connection when times out or all data written.
	bool my_turn; //currently this client's turn
};

#endif //CLIENT_HPP
