#ifndef GAMESTATE_HPP
#define GAMESTATE_HPP

#include <Vector/Vector.hpp>

#include <ev.h>
#include <vector>
#include <string>
#include <iostream>

using std::vector;
using std::string;
using std::cout;
using std::endl;

class Client;

class GameState {
public:
	GameState();
	virtual ~GameState();
	virtual void reinit();

	// turn functions
	void attack(Client* c);			// attempt to rob enemy of next turn
	void defend(Client* c);			// defend yourself from attacks next turn
	void hang(Client* c);			// put clothing on clothes line, bumping off enemy's
	void endedTurn(bool youAreA);	// the function called at the end of every turn; not an action
	//void broadcast(string s);

	// game functions
	bool get_turn(Client* c);
	void win(bool aWon);
	// helper functions
	bool finished();

	// Variables
	bool game_on;
	bool comatose;
	Client* player1;
	Client* player2;
	//list<string> broadcastA;
	//list<string> broadcastB;
	//ev_timer update_watcher;

	bool turn_A;				// if true, A's turn;	if false, B's turn
	int def_A;	int def_B;		// if positive, enemy attacks less effective
	int hp_A;	int hp_B;		// if not positive, your turn is skipped
	int pts_A;	int pts_B;		// how many you have hung up
};

#endif //GAMESTATE_HPP
